<?php
  global $SITEURL, $success;
  $msgs = array();
  if (isset($_POST['save'])) {
    $stdfields = array('pubDate','title','url','meta','metad','menu','menuStatus','menuOrder',
                        'template','parent','content','private');
 		$data = @new SimpleXMLExtended('<?xml version="1.0" encoding="UTF-8"?><channel></channel>');
    for ($i=0; isset($_POST['cf_'.$i.'_key']); $i++) {
      if ($_POST['cf_'.$i.'_key']) {
        if (in_array($_POST['cf_'.$i.'_key'], $stdfields)) {
          $msgs[] = '<strong>'.htmlspecialchars($_POST['cf_'.$i.'_key']).'</strong> is a reserved name!';
        } else {
          $item = $data->addChild('item');
          $item->addChild('desc', htmlspecialchars($_POST['cf_'.$i.'_key'], ENT_QUOTES));
          $item->addChild('label', htmlspecialchars($_POST['cf_'.$i.'_label'], ENT_QUOTES));
          $item->addChild('type', htmlspecialchars($_POST['cf_'.$i.'_type'], ENT_QUOTES));
          if ($_POST['cf_'.$i.'_value']) {
            $item->addChild('value', htmlspecialchars($_POST['cf_'.$i.'_value'], ENT_QUOTES));
          }
          if ($_POST['cf_'.$i.'_options']) {
            $options = preg_split("/\r?\n/", rtrim($_POST['cf_'.$i.'_options']));
            foreach ($options as $option) {
              $item->addChild('option', htmlspecialchars($option, ENT_QUOTES));
            } 
          }
        } 
      }
    }
 		XMLsave($data, GSDATAOTHERPATH . I18N_CUSTOMFIELDS_FILE);
    if (count($msgs) > 0) {
      $msgs[] = 'All other custom fields have been successfully saved!';
    } else {
      $msgs[] = 'Custom fields have been successfully saved!';
    }
  }
  $defs = i18n_customfield_defs();
?>
<label>Custom Fields</label>
<p class="clear">This plugin allows you to specify custom fields which are displayed when you edit a page.</p>
<p>These fields can be accessed in your themes:</p>
<ul>
  <li><code>&lt;?php get_custom_field($name); ?&gt;</code> will display the corresponding field value for the current page</li>  
  <li><code>return_custom_field($name)</code> will return the field value for further processing</li>
</ul>
<p>Below you can configure the custom fields. Drag the rows to reorder the fields. 
  Deleting fields does not remove the field values from the pages.
  The default value is the initial value for new pages.</p>
<form method="post" id="customfieldsForm">
  <table id="editfields" class="edittable highlight">
    <thead><tr><th>Name</th><th>Label</th><th style="width:100px;">Type</th><th>Default Value</th><th></th></tr></thead>
    <tbody>
<?php
  $i = 0; 
  if (count($defs) > 0) foreach ($defs as $def) {
    i18n_customfields_confline($i, $def, 'sortable');    
    $i++;
  }
  i18n_customfields_confline($i, array(), 'hidden'); 
?> 
      <tr>
        <td colspan="4"><a href="#" class="add">Add new field</a></td>
        <td class="secondarylink"><a href="#" class="add" title="Add new field">+</a></td>
      </tr>
    </tbody>
  </table>
  <input type="submit" name="save" value="Save Custom Fields" class="submit"/>
</form>
<script type="text/javascript" src="<?php echo $SITEURL; ?>/plugins/i18n_customfields/js/jquery-ui.sort.min.js"></script>
<script type="text/javascript">
  function renumberCustomFields() {
    $('#customfieldsForm table tbody tr').each(function(i,tr) {
      $(tr).find('input, select, textarea').each(function(k,elem) {
        var name = $(elem).attr('name').replace(/_\d+_/, '_'+(i)+'_');
        $(elem).attr('name', name);
      });
    });
  }
  $(function() {
    $('select[name$=_type]').change(function(e) {
      var val = $(e.target).val();
      var $ta = $(e.target).closest('td').find('textarea');
      if (val == 'dropdown') $ta.css('display','inline'); else $ta.css('display','none');
    });
    $('a.delete').click(function(e) {
      $(e.target).closest('tr').remove();
      renumberCustomFields();
    });
    $('a.add').click(function(e) {
      var $tr = $(e.target).closest('tbody').find('tr.hidden');
      $tr.before($tr.clone(true).removeClass('hidden').addClass('sortable'));
      renumberCustomFields();
    });
    $('#customfieldsForm tbody').sortable({
      items:"tr.sortable", handle:'td',
      update:function(e,ui) { renumberCustomFields(); }
    });
    renumberCustomFields();
<?php if (count($msgs) > 0) { ?>
    $('div.bodycontent').before('<div class="updated" style="display:block;">'+<?php echo json_encode(implode('<br/>', $msgs)); ?>+'</div>');
<?php } ?>
  });
</script>
<?php

function i18n_customfields_confline($i, $def, $class='') {
  $isdropdown = @$def['type'] == 'dropdown';
  $options = "\r\n";
  if ($isdropdown && count($def['options']) > 0) {
    foreach ($def['options'] as $option) $options .= $option . "\r\n";
  } 
?>
      <tr class="<?php echo $class; ?>">
        <td><input type="text" class="text" style="width:80px;padding:2px;" name="cf_<?php echo $i; ?>_key" value="<?php echo @$def['key'];?>"/></td>
        <td><input type="text" class="text" style="width:140px;padding:2px;" name="cf_<?php echo $i; ?>_label" value="<?php echo htmlspecialchars(@$def['label']);?>"/></td>
        <td>
          <select name="cf_<?php echo $i; ?>_type" class="text short" style="width:180px;padding:2px;" >
            <option value="text" <?php echo @$def['type']=='text' ? 'selected="selected"' : ''; ?> >Text field</option>
            <option value="textfull" <?php echo @$def['type']=='textfull' ? 'selected="selected"' : ''; ?> >Long text field</option>
            <option value="dropdown" <?php echo @$def['type']=='dropdown' ? 'selected="selected"' : ''; ?> >Dropdown box</option>
            <option value="checkbox" <?php echo @$def['type']=='checkbox' ? 'selected="selected"' : ''; ?> >Check box</option>
            <option value="textarea" <?php echo @$def['type']=='textarea' ? 'selected="selected"' : ''; ?> >WYSIWYG Editor</option>
          </select>
          <textarea class="text" style="width:170px;height:50px;padding:2px;<?php echo !$isdropdown ? 'display:none' : ''; ?>" name="cf_<?php echo $i; ?>_options"><?php echo $options; ?></textarea> 
        </td>
        <td><input type="text" class="text" style="width:100px;padding:2px;" name="cf_<?php echo $i; ?>_value" value="<?php echo @$def['value'];?>"/></td>
        <td class="delete"><a href="#" class="delete" title="Delete field">X</a></td>
      </tr>
<?php 
}


